<?php

declare(strict_types=1);

namespace Drupal\openapi_test\Plugin\Field\FieldType;

use Drupal\Core\Field\FieldStorageDefinitionInterface;
use Drupal\Core\Field\Plugin\Field\FieldType\MapItem;
use Drupal\Core\Serialization\Attribute\JsonSchema;

/**
 * Field type with JSON data storage.
 *
 * @FieldType(
 *   id = "openapi_json_backed_test",
 *   label = @Translation("JSON-backed field (test)"),
 *   description = @Translation("A field containing JSON-backed properties."),
 * )
 */
class JsonBackedPropertiesItem  extends MapItem {

  /**
   * {@inheritdoc}
   */
  public static function schema(FieldStorageDefinitionInterface $field_definition) {
    return [
      'columns' => [
        'json_value' => [
          'type' => 'json',
        ],
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  #[JsonSchema([
    'type' => 'object',
    'properties' => [
      'property1' => ['type' => 'string'],
      'property2' => ['type' => 'boolean'],
    ],
  ])]
  public function getValue() {
    return parent::getValue();
  }

}
